;----------------------------------------------
(Vmon)  ;Virtual memory on
(Setvar "cmdecho" 0)
(Setq i 0)
(Foreach N '("cc" "pp" "mt" "onekey" "TS" "TCC" "TCCC" "TA" "NP" "XM" "CUT" "MO" "MC" "ARR" "SL" "ct" "sb" "join" "hj" "leo" "CX" "de" "ddc" "color"
             "df" "ff" "XG" "3d2d" "lad" "ddunit" "cl" "lk" "uk" "a3" "app" "a1" "view" "k" "j" "hh" "hhh" "hg" "PG" "af" "bx" "allplot" "pljoin")
   (Setq OpLip (Strcat N ".lsp"))
   (If (/= nil (FindFile OpLip))
      (progn
         (load N)
      )
      (Progn
         (If (= i 0)
            (Progn
               (Prompt "\nNot Loading Lisp Programs...")
               (Setq i 1)
            )
         )
         (Prompt "\nThe file '")
         (Prompt OpLip)
         (Prompt "' was not found in your current search directories.")
         (Princ)
      )
   )
)
(If (= i 1)
    (Progn
       (Setq i 0)
       (Prompt "\nLoading Programs...")
    )
)
(setq e (ssget "x" (list (cons 2 "bord"))))
(if (= e nil) (setq e (ssget "x" (list (cons 2 "won")))))
(if (= e nil) (setq e (ssget "x" (list (cons 2 "sun")))))
(if (/= e nil)
   (progn
      (setq t (entget (ssname e 0)))
      (setq xx (cdr (assoc 41 t)))
      (setq Stext (strcat "1/" (rtos (* xx 50.0))))
      (prompt "\nNow Drawing Scale is ")
      (prompt Stext) (prompt "\n")
      (Setvar "Ltscale" (* xx 0.5))
      (Setvar "Pdsize" (* xx 0.5))
      (Setvar "Dimscale" (* xx 1))
      (Setvar "Textsize" (* xx 250.0))
      (Setvar "Dimtxt" (* xx 250.0))
      (Setvar "Dimasz" (* xx 250.0))
   )
   (prompt "Not Scale")
)
(Setvar "Pickbox" 5)
(Setvar "Blipmode" 0)
(Setvar "Osmode" 59)
(princ)