;;cutting box (93.11)
(defun c:cut (/ sp ep ss1 dp up mp ss2 num k nm obj)
   (graphscr)
   (setvar "cmdecho" 0)
   (prompt "\nCommand: Cutting Box...")
   (setq sp (getpoint "\nPick a first corner of cut-box ->")
         ep (getcorner sp "\nOther corner->")
         ss1 (ssget "c" sp ep)
         dp (list (car ep) (cadr sp))
         up (list (car sp) (cadr ep))
         mp (polar sp (angle sp ep) (/ (distance sp ep) 2)) )
   (command "pline" sp dp ep up "c")
   (setq ss2 (ssget "L")  num (sslength ss1)  k 0)
   (while (< k num)
      (setq nm (ssname ss1 k)  obj (list nm mp))
      (command "trim" ss2 "" obj "")
      (setq k (1+ k))
   )
   (command "erase" ss2 "")
   (setvar "highlight" 1)
   (prin1)
)