;------------------------------------------------------------------------------------------
; LAYER ADJUSTING PROGRAM  
; '98.10.13  SEOUL R.B.C.  KIM H. M.(zealous@eec.co.kr)
; '98.10.13 LAST UPDATED

(defun c:lad(/ stat curr lanmlst box_p sour)
  
  (defun layer_select (cur / dcl_id)

      (setq laname (nth (atoi cur) lanmlst))
      (command "layer" "t" laname "")
      (command "layer" "s" laname "")
      (command "layer" "f" "*" "")
      ;(command "layer" "t" laname "")  
      (setq dcl_id (load_dialog "lad.dcl"))
      (if (not (new_dialog "lad" dcl_id "" box_p)) (exit))
      (start_list "list_l")
      (mapcar 'add_list lanmlst)  ; initialize list box
      (end_list)
      (set_tile "list_l" cur)
      ;(action_tile "list_l" "(lalist_act $value)")
      (action_tile "list_l" "(setq box_p (done_dialog 2))(setq curr $value)")
      (action_tile "move"    "(done_dialog 3)")
      (action_tile "accept"  "(done_dialog 1)")
      (action_tile "cancel"  "(done_dialog 0)")
      (setq stat (start_dialog))
      (unload_dialog dcl_id)
      ;(if (or (= stat 0) (= stat 1)) ; OK or Cancel
      ;   (progn	
      ;   (unload_dialog dcl_id)
      ;   (quit)
      ;   )
      ;)  if's end
  )

  (defun lalist_act (index)
     (setq box_p (done_dialog 2))
     (setq curr index)
  )
  
  (defun make_la_lists (/ sortlist templist _name)
     (setq sortlist nil)
     (setq templist (tblnext "LAYER" T))
     (while templist
	(setq _name (cdr (assoc 2 templist)))
	(setq sortlist (cons _name sortlist))
	(setq templist (tblnext "LAYER"))
     )
     (if (>= (getvar "maxsort") (length sortlist))
	(setq sortlist (acad_strlsort sortlist))
	(setq sortlist (reverse sortlist))
     )
     (setq lanmlst sortlist)
  )

 ;------------------------Main start----------------------------------

  (setq box_p (list -1 -1))
  (setq curr "0")
  (setq stat 2) 
  (make_la_lists)
  (while (>= stat 2)
     (layer_select curr)
     (if (= stat 3)
         (progn
         (setq sour (ssget))
         (while (/= sour nil)
            (load "lad_lc.lsp")
            (lad_lc sour)
            (setq sour (ssget))
         ))
     )
  )
  (command "layer" "t" "*" "")
)     ; Program's End
