;------------------------------------------------------------------------------------------
; LAYER CHANGING PROGRAM FOR LAD.LSP PROGRAM  
; '97.07.21  SEOUL R.B.C.  KIM H. M.
; '97.07.21 LAST UPDATED

(defun lad_lc (sour / _layer enty_list enty_name layer sel_num i laname)

  (defun getlayer ()
      (make_la_lists)
      (setq la-idx 0)     
      (setq dcl_id (load_dialog "lad_lc.dcl"))
      (if (not (new_dialog "lad_lc" dcl_id)) (exit))
      (start_list "list_la")
      (mapcar 'add_list lanmlst)  ; initialize list box
      (end_list)
      (lalist_act (itoa la-idx))

      (action_tile "list_la" "(lalist_act $value)")
      (action_tile "accept" "(done_dialog 1)")
      (action_tile "cancel" "(done_dialog 0)")

      (if (= (start_dialog) 1) ; User pressed OK
         (progn
            (unload_dialog dcl_id)
            (setq laname laname)
         )
         (progn
	    (unload_dialog dcl_id)
            (setq laname nil)
         )
      )  if's end
      laname
  )
  
  (defun lalist_act (index)
    (setq la-idx (atoi index))
    (setq laname (nth la-idx lanmlst))
    (set_tile "list_la" (itoa la-idx))
  )

  
  (defun make_la_lists (/ sortlist templist _name)
     (setq sortlist nil)
     (setq templist (tblnext "LAYER" T))
     (while templist
	(setq _name (cdr (assoc 2 templist)))
	(setq sortlist (cons _name sortlist))
	(setq templist (tblnext "LAYER"))
     )
     (if(>= (getvar "maxsort") (length sortlist))
	(setq sortlist (acad_strlsort sortlist))
	(setq sortlist (reverse sortlist))
     )
     (setq lanmlst sortlist)
  )
;-------------------------------<Main>--------------------------------
    (setq i 0)
    (setq _layer (getlayer))
    (if (/= _layer nil)
       (progn
       (setq sel_num (sslength sour))
       (repeat sel_num
	    (setq enty_name (ssname sour i))
            (setq enty_list (entget enty_name))
	    (setq layer (assoc 8 enty_list))
	    (setq enty_list (subst (cons 8 _layer) layer enty_list))
	    (entmod enty_list)
	    (setq i (+ i 1))
       )  ; Repeat's End
       )
    )
)  ; Program's End
