;;===========================================================
;  MULTIPLE OFFSET (96cho_i)
;;-----------------------------------------------------------
(defun c:mo(/ myerror bl ss pt1 pt2 ang1 d1 d2)
   ;start --- Internal error handler ----------
    (defun myerror(S)
    (if (/= s "Function cancelled")(princ (strcat "\nError:" s)))
    (setvar "blipmode" bl)
    (setq *error* olderr)(princ) )
    (setq olderr *error* *error* myerror)
   ;end----------------------------------------
   (setvar "cmdecho" 0)
   (setq bl (getvar "blipmode"))
   (prompt "\nCommand: Multi Offset...")
   (setq ss (ssget))
   (setq pt1 (getpoint "\nBase point->"))
   (setq pt2 (getpoint pt1 "\nSecond point->"))
   (setq ang1 (angle pt1 pt2))
   (if (= mod1 nil) (setq mod1 100))
   (setq d1 (getdist (strcat
              "\nEnter Offset Distance <" (rtos mod1 2 0) ">:")))
   (if (= d1 nil) (setq d1 mod1))
   (setq mod1 d1)
   (while (/= d2 0)
      (setq p2 (polar pt1 ang1 d1))
      (command "copy" ss "" pt1 p2)
      (setq d2 (getdist (strcat
                 "\nEnter Offset Distance <" (rtos mod1 2 0) ">:")))
      (if (= d2 nil) (setq d2 mod1))
      (if (/= d2 0) (setq mod1 d2))
      (setq d1 (+ d1 d2))
   )
   (prin1)
)
