(Defun *ERROR* (St)
       (Terpri)
       (Princ "\nerror: ")
       (Princ st)
       (Princ)
)

(Defun Chgterr (s)
   (If (/= s "Function cancelled")
      (Princ (Strcat "\nError: " s))
   )
   (Setq p Nil)
   (Setq *error* Olderr)
   (Princ)
)

(Defun C:B(/ ss sno pt1 pt2 no x)
       (Princ " = BREAK2P")
       (Setq ss (ssget))
       (Setq sno (sslength ss))
       (Setq pt1 (getpoint "\n>>> First Point : "))
       (Setq pt2 (getpoint pt1 "\n>>> Second Point : "))
       (Setq no 0)
       (repeat sno
	   (Setq x (ssname ss no))
	   (Command "break" x pt1 pt2)
	   (Setq no (1+ no))
       )(Prin1)
)



(Defun C:CCT (/ p l n e os as ns st s nsl osl sl si chf chm olderr)
   (Setq olderr  *error*	     ; Initialize variables
	 *error* chgterr
	 chm	 0)
   (Setq p (ssget))		     ; **۾ ã ٲٱ--> Select objects
   (If p (progn 		     ; If any objects selected
      (while (= 0 (Setq osl (strlen (Setq os (getstring t "\nOld string: ")))))
	    (Princ "Null input invalid")
      )
      (Setq nsl (strlen (Setq ns (getstring t "\nNew string: "))))
      (Setq l 0 n (sslength p))
      (while (< l n)		     ; For each selected object...
	 (If (= "TEXT"               ; Look for TEXT entity type (group 0)
		(cdr (assoc 0 (Setq e (entget (ssname p l))))))
	    (progn
	       (Setq chf Nil si 1)
	       (Setq s (cdr (Setq as (assoc 1 e))))
	       (while (= osl (Setq sl (strlen
			     (Setq st (substr s si osl)))))
		  (If (= st os)
		      (progn
			(Setq s (strcat (substr s 1 (1- si)) ns
					(substr s (+ si osl))))
			(Setq chf t) ; Found old string
			(Setq si (+ si nsl))
		      )
		      (Setq si (1+ si))
		  )
	       )
	       (If chf (progn	     ; Substitute new string for old
		  (Setq e (subst (cons 1 s) as e))
		  (entmod e)	     ; ModIfy the TEXT entity
		  (Setq chm (1+ chm))
	       ))
	    )
	 )
	 (Setq l (1+ l))
      )
   ))
   (Princ "Changed ")                ; Print total lines changed
   (Princ chm)
   (Princ " text lines.")
   (terPri)
   (Setq *error* olderr)	     ; Restore old *error* handler
)

(defun C:FL()
   (Setvar "cmdecho" 0)
   (setq aa (entsel "\n **ü Ʈ /ص -- Select object: "))
   (setq flay (cdr (assoc 8 (entget (car aa)))))
   (command "layer" "f" flay "")
   (setvar "osmode" 0)
   (princ)
)

(Defun C:G()
       (Princ " = ZOOM PREVIOUS")
       (Command "zoom" "P")(Prin1)
)

(Defun C:LA11()
       (Princ " = LAYER-LOCK1")
       (Setq a (entget (car (entsel))))
       (setq en (assoc 8 a))
       (setq gn (cdr en))
       (Command "layer" "lo" gn "")(Prin1)
)

(Defun C:LA12()
       (Princ " = LAYER-LOCK2")
       (Setq a (entget (car (entsel))))
       (setq en (assoc 8 a))
       (setq gn (cdr en))
       (Command "layer" "lo" "*" "")(Prin1)
       (Command "layer" "u" gn "")(Prin1)
)

(Defun C:OF()
       (Princ " = LAYER-OFF1")
       (Setq a (entget (car (entsel))))
       (setq en (assoc 8 a))
       (setq gn (cdr en))
       (If (= gn (getvar "clayer"))
           (Command "layer" "off" gn "y" "")
           (Command "layer" "off" gn "")
       )(Prin1)
)

(Defun C:LA22()
       (Princ " = LAYER-OFF2")
       (Setq a (entget (car (entsel))))
       (setq en (assoc 8 a))
       (setq gn (cdr en))
       (Command "layer" "off" "*" "y" "")(Prin1)
       (Command "layer" "on" gn "")(Prin1)
)

(Defun C:Q()
       (setvar "CMDECHO" 0)
       (princ "= AutoCad Quit")
       (command "Quit")(prin1)
)

(Defun C:ST()
       (Princ " = STRETCH")
       (Command "stretch" "c")(Prin1)
)

(defun C:TL()
   (setvar "cmdecho" 0)
   (setq unlay (getstring "\nInsert thaw layer name(U: Unfreeze): "))
   (if (or (= unlay "U") (= unlay "u"))
      (progn (command "layer" "t" flay ""))
      (progn (command "layer" "t" unlay ""))
   )
   (Setvar "osmode" 0)
   (princ)
)

(Defun C:uu()
       (Princ " = UN-LOCK")
       (Command "layer" "u" "*" "")(Prin1)
)

(Defun C:ZA()
       (Princ " = ZOOM ALL")
       (Command "zoom" "A")(Prin1)
)
(Defun C:aD()
       (Princ " = ZOOM DYNAMIC")
       (Command "zoom" "D")(Prin1)
)
(Defun C:aE()
       (Princ " = ZOOM EXTENTS")
       (Command "zoom" "E")(Prin1)
)

;;OSMODE

(Defun C:N()
       (Princ " = OSMODE NON")
       (Setvar "Osmode" 0)(Prin1)
)

(Defun C:OE()
       (Princ " = OSMODE END")
       (Setvar "Osmode" 1)(Prin1)
)

(Defun C:OM()
       (Princ " = OSMODE MID")
       (Setvar "Osmode" 2)(Prin1)
)

(Defun C:OC()
       (Princ " = OSMODE CEN")
       (Setvar "Osmode" 4)(Prin1)
)

(Defun C:ONn()
       (Princ " = OSMODE NODE")
       (Setvar "Osmode" 8)(Prin1)
)

(Defun C:OQ()
       (Princ " = OSMODE QUAD")
       (Setvar "Osmode" 16)(Prin1)
)

(Defun C:OI()
       (Princ " = OSMODE INT")
       (Setvar "Osmode" 32)(Prin1)
)

(Defun C:OP()
       (Princ " = OSMODE PER")
       (Setvar "Osmode" 128)(Prin1)
)
(defun c:gg(/)
(setq ts (ssget))
 (command "change" ts "" "p" "c" "byl" "")
)

;;;;;۾ style ;;;;;;;;;;;

(defun c:ss(/ ts l sZ i l1 t1 t2 t0 h)
(if (not (tblsearch "style" "SS"))
      (command "style" "SS" "SES,SHS" "" "" "" "" "" "")
)
(setq ts(ssget))
(SETQ L(SSLENGTH ts))
(setq sz "SS")
(setq i 0)
(setq l1(- l 1))
(while (<= i l1)
(setq t1(ssname ts i))
(setq t2(entget t1))
(setq t0(cdr (assoc 0 t2)))
(cond ((= "TEXT" t0)
(PROGN (setq h SZ)
(setq t2(subst (cons 7 h)(assoc 7 t2) t2))
(entmod t2)
)
)
(t nill)
)
(setq i(+ i 1))
)
)





(defun c:wt(/ ts l sZ i l1 t1 t2 t0 h)
(if (not (tblsearch "style" "ST"))
(COMMAND "style" "st" "HY︪L" "" "" "" "" "" "")
)
(setq ts(ssget))
(SETQ L(SSLENGTH ts))
(setq sz "st")
(setq i 0)
(setq l1(- l 1))
(while (<= i l1)
(setq t1(ssname ts i))
(setq t2(entget t1))
(setq t0(cdr (assoc 0 t2)))
(cond ((= "TEXT" t0)
(PROGN (setq h SZ)
(setq t2(subst (cons 7 h)(assoc 7 t2) t2))
(entmod t2)
)
)
(t nill)
)
(setq i(+ i 1))
)
)
(defun c:wtt(/ ts l sZ i l1 t1 t2 t0 h)
(if (not (tblsearch "style" "wT"))
(COMMAND "style" "wt" "HY︪m" "" "" "" "" "" "")
)
(setq ts(ssget))
(SETQ L(SSLENGTH ts))
(setq sz "wt")
(setq i 0)
(setq l1(- l 1))
(while (<= i l1)
(setq t1(ssname ts i))
(setq t2(entget t1))
(setq t0(cdr (assoc 0 t2)))
(cond ((= "TEXT" t0)
(PROGN (setq h SZ)
(setq t2(subst (cons 7 h)(assoc 7 t2) t2))
(entmod t2)
)
)
(t nill)
)
(setq i(+ i 1))
)
)